/* Macro definitions for Alpha-based NetApp box.
   Copyright 1993 Free Software Foundation, Inc.

This file is part of GDB.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef TM_ALPHA_NETAPP_H
#define TM_ALPHA_NETAPP_H

#include "tm-netapp.h"

/* Most definitions from alpha could be used. */
#include "alpha/tm-alpha.h"

/* Override the standard Alpha "we're in the signal trampoline" definition. */

#undef IN_SIGTRAMP

/* We're in the "signal" (trap) trampoline if we're in "instruction_fault",
   "mm_fault", "unaligned_fault", "arithmetic_trap", or "interrupt". */

#define IN_SIGTRAMP(pc, name) (name && \
		(STREQ ("instruction_fault", name) \
	      || STREQ ("mm_fault", name) \
	      || STREQ ("unaligned_fault", name) \
	      || STREQ ("arithmetic_trap", name) \
	      || STREQ ("interrupt", name)))

/* XXX - gross hack to get NetApp box interrupt/trap/fault frame stuff. */

#define	XXX_NETAPP_XXX

#if 0
/* Saved Pc.  Skip over trap error code if within sigtramp.  */

#undef FRAME_SAVED_PC(FRAME)
#define FRAME_SAVED_PC(FRAME) \
  (((FRAME)->signal_handler_caller \
    ? read_memory_integer ((FRAME)->frame + 8, 4) \
    : read_memory_integer ((FRAME)->frame + 4, 4)) \
   )

/* We don't want to treat the first object file as the startup code,
   as it'll then think "alltraps" is part of the startup code,
   and will stop the stack trace when it hits "alltraps".

   For now, we just disable the check for the current PC; we may
   have to put in the "right" check later. */

#define FRAME_CHAIN_VALID(chain, thisframe) (chain != 0)

/* FRAME_CHAIN takes a frame's nominal address and produces the frame's
   chain-pointer.

   We special-case trap frames (frames with a non-zero
   "signal_handler_caller"), because the PC in them may be bogus and,
   as such, we may not be able to get a procedure descriptor. */
#undef FRAME_CHAIN
#define FRAME_CHAIN(thisframe)  \
  (thisframe->signal_handler_caller \
   ? thisframe->frame \
   : (CORE_ADDR) alpha_frame_chain (thisframe))
#endif

/* Translate a signal handler frame into the address of the sigcontext
   structure.  */

#undef SIGCONTEXT_ADDR
#define SIGCONTEXT_ADDR(frame)			((frame)->frame - IF_SIZE)

#endif /* TM_ALPHA_NETAPP_H */
